OGRE: Ogre::DDSCodec Class Reference - OGRE Documentation

# Ogre::DDSCodec Class Reference

Codec specialized in loading DDS (Direct Draw Surface) images. More...

`#include <OgreDDSCodec.h>`

Inheritance diagram for Ogre::DDSCodec:

[legend]

List of all members.

## Public Types
typedef SharedPtr< CodecData > | CodecDataPtr
typedef ConstMapIterator < CodecList > | CodecIterator
typedef std::pair < MemoryDataStreamPtr, CodecDataPtr > | DecodeResult
| Result of a decoding; both a decoded data stream and CodecData metadata.
## Public Member Functions
| DDSCodec ()
virtual | ~DDSCodec ()
DataStreamPtr | code (MemoryDataStreamPtr &input, CodecDataPtr &pData) const
| Codes the data in the input stream and saves the result in the output stream.
void | codeToFile (MemoryDataStreamPtr &input, const String &outFileName, CodecDataPtr &pData) const
  | Codes the data in the input chunk and saves the result in the output filename provided. Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations. Parameters:
  | input | The input data
  | outFileName | The filename to write to
  | pData | Extra information to be passed to the codec (codec type specific)
DecodeResult | decode (DataStreamPtr &input) const
  | Codes the data from the input chunk into the output chunk. Parameters:
  | input | Stream containing the encoded data
Note: Has a variable number of arguments, which depend on the codec type.
String | magicNumberToFileExt (const char *magicNumberPtr, size_t maxbytes) const
  | Maps a magic number header to a file extension, if this codec recognises it. Parameters:
  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed
Returns: A blank string if the magic number was unknown, or a file extension.
virtual String | getType () const
| Returns the type of the codec as a String.
String | getDataType () const
| Returns the type of the data that supported by this codec as a String.
virtual bool | magicNumberMatch (const char *magicNumberPtr, size_t maxbytes) const
| Returns whether a magic number header matches this codec.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | startup (void)
| Static method to startup and register the DDS codec.
static void | shutdown (void)
| Static method to shutdown and unregister the DDS codec.
static void | registerCodec (Codec *pCodec)
| Registers a new codec in the database.
static void | unRegisterCodec (Codec *pCodec)
| Unregisters a codec from the database.
static CodecIterator | getCodecIterator (void)
| Gets the iterator for the registered codecs.
static StringVector | getExtensions (void)
| Gets the file extension list for the registered codecs.
static Codec * | getCodec (const String &extension)
| Gets the codec registered for the passed in file extension.
static Codec * | getCodec (char *magicNumberPtr, size_t maxbytes)
| Gets the codec that can handle the given 'magic' identifier.
## Protected Types
typedef std::map< String, Codec * > | CodecList
## Static Protected Attributes
static CodecList | ms_mapCodecs
| A map that contains all the registered codecs.
## Private Member Functions
void | flipEndian (void *pData, size_t size, size_t count) const
void | flipEndian (void *pData, size_t size) const
PixelFormat | convertFourCCFormat (uint32 fourcc) const
PixelFormat | convertPixelFormat (uint32 rgbBits, uint32 rMask, uint32 gMask, uint32 bMask, uint32 aMask) const
void | unpackDXTColour (PixelFormat pf, const DXTColourBlock &block, ColourValue *pCol) const
| Unpack DXT colours into array of 16 colour values.
void | unpackDXTAlpha (const DXTExplicitAlphaBlock &block, ColourValue *pCol) const
| Unpack DXT alphas into array of 16 colour values.
void | unpackDXTAlpha (const DXTInterpolatedAlphaBlock &block, ColourValue *pCol) const
| Unpack DXT alphas into array of 16 colour values.
## Private Attributes
String | mType
## Static Private Attributes
static DDSCodec * | msInstance
| Single registered codec instance.

## Detailed Description

Codec specialized in loading DDS (Direct Draw Surface) images.

Remarks:
  We implement our own codec here since we need to be able to keep DXT data compressed if the card supports it.

Definition at line 45 of file OgreDDSCodec.h.

## Member Typedef Documentation

typedef std::map< String, Codec* > Ogre::Codec::CodecList`[protected, inherited]`

Definition at line 52 of file OgreCodec.h.

typedef SharedPtr<CodecData> Ogre::Codec::CodecDataPtr`[inherited]`

Definition at line 67 of file OgreCodec.h.

typedef ConstMapIterator<CodecList> Ogre::Codec::CodecIterator`[inherited]`

Definition at line 69 of file OgreCodec.h.

typedef std::pair<MemoryDataStreamPtr, CodecDataPtr> Ogre::Codec::DecodeResult`[inherited]`

Result of a decoding; both a decoded data stream and CodecData metadata.

Definition at line 122 of file OgreCodec.h.

## Constructor & Destructor Documentation

Ogre::DDSCodec::DDSCodec | ( |  | ) |

virtual Ogre::DDSCodec::~DDSCodec | ( |  | ) | `[virtual]`

Definition at line 68 of file OgreDDSCodec.h.

## Member Function Documentation

void Ogre::DDSCodec::flipEndian | ( | void * | pData,
|  | size_t | size,
|  | size_t | count |
| ) |  |  | const`[private]`

void Ogre::DDSCodec::flipEndian | ( | void * | pData,
|  | size_t | size |
| ) |  |  | const`[private]`

PixelFormat Ogre::DDSCodec::convertFourCCFormat | ( | uint32 | fourcc | ) | const`[private]`

PixelFormat Ogre::DDSCodec::convertPixelFormat | ( | uint32 | rgbBits,
|  | uint32 | rMask,
|  | uint32 | gMask,
|  | uint32 | bMask,
|  | uint32 | aMask |
| ) |  |  | const`[private]`

void Ogre::DDSCodec::unpackDXTColour | ( | PixelFormat | pf,
|  | const DXTColourBlock & | block,
|  | ColourValue * | pCol |
| ) |  |  | const`[private]`

Unpack DXT colours into array of 16 colour values.

void Ogre::DDSCodec::unpackDXTAlpha | ( | const DXTExplicitAlphaBlock & | block,
|  | ColourValue * | pCol |
| ) |  |  | const`[private]`

Unpack DXT alphas into array of 16 colour values.

void Ogre::DDSCodec::unpackDXTAlpha | ( | const DXTInterpolatedAlphaBlock & | block,
|  | ColourValue * | pCol |
| ) |  |  | const`[private]`

Unpack DXT alphas into array of 16 colour values.

DataStreamPtr Ogre::DDSCodec::code | ( | MemoryDataStreamPtr & | input,
|  | CodecDataPtr & | pData |
| ) |  |  | const`[virtual]`

Codes the data in the input stream and saves the result in the output stream.

Implements Ogre::Codec.

void Ogre::DDSCodec::codeToFile | ( | MemoryDataStreamPtr & | input,
|  | const String & | outFileName,
|  | CodecDataPtr & | pData |
| ) |  |  | const`[virtual]`

Codes the data in the input chunk and saves the result in the output filename provided.

Provided for efficiency since coding to memory is progressive therefore memory required is unknown leading to reallocations.

Parameters:

  | input | The input data
  | outFileName | The filename to write to
  | pData | Extra information to be passed to the codec (codec type specific)

Implements Ogre::Codec.

DecodeResult Ogre::DDSCodec::decode | ( | DataStreamPtr & | input | ) | const`[virtual]`

Codes the data from the input chunk into the output chunk.

Parameters:

  | input | Stream containing the encoded data

Note:
  Has a variable number of arguments, which depend on the codec type.

Implements Ogre::Codec.

String Ogre::DDSCodec::magicNumberToFileExt | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes |
| ) |  |  | const`[virtual]`

Maps a magic number header to a file extension, if this codec recognises it.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

Returns:
  A blank string if the magic number was unknown, or a file extension.

Implements Ogre::Codec.

virtual String Ogre::DDSCodec::getType | ( |  | ) | const`[virtual]`

Returns the type of the codec as a String.

Implements Ogre::Codec.

static void Ogre::DDSCodec::startup | ( | void |  | ) | `[static]`

Static method to startup and register the DDS codec.

static void Ogre::DDSCodec::shutdown | ( | void |  | ) | `[static]`

Static method to shutdown and unregister the DDS codec.

String Ogre::ImageCodec::getDataType | ( |  | ) | const`[virtual, inherited]`

Returns the type of the data that supported by this codec as a String.

Implements Ogre::Codec.

Definition at line 74 of file OgreImageCodec.h.

static void Ogre::Codec::registerCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

Registers a new codec in the database.

Definition at line 76 of file OgreCodec.h.

References Ogre::Codec::getType().

static void Ogre::Codec::unRegisterCodec | ( | Codec * | pCodec | ) | `[static, inherited]`

Unregisters a codec from the database.

Definition at line 83 of file OgreCodec.h.

References Ogre::Codec::getType().

static CodecIterator Ogre::Codec::getCodecIterator | ( | void |  | ) | `[static, inherited]`

Gets the iterator for the registered codecs.

Definition at line 89 of file OgreCodec.h.

static StringVector Ogre::Codec::getExtensions | ( | void |  | ) | `[static, inherited]`

Gets the file extension list for the registered codecs.

static Codec* Ogre::Codec::getCodec | ( | const String & | extension | ) | `[static, inherited]`

Gets the codec registered for the passed in file extension.

static Codec* Ogre::Codec::getCodec | ( | char * | magicNumberPtr,
|  | size_t | maxbytes |
| ) |  |  | `[static, inherited]`

Gets the codec that can handle the given 'magic' identifier.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

virtual bool Ogre::Codec::magicNumberMatch | ( | const char * | magicNumberPtr,
|  | size_t | maxbytes |
| ) |  |  | const`[virtual, inherited]`

Returns whether a magic number header matches this codec.

Parameters:

  | magicNumberPtr | Pointer to a stream of bytes which should identify the file. Note that this may be more than needed - each codec may be looking for a different size magic number.
  | maxbytes | The number of bytes passed

Definition at line 144 of file OgreCodec.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 62 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 73 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 79 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 84 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 89 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 106 of file OgreMemoryAllocatedObject.h.

template<class Alloc>

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

## Member Data Documentation

String Ogre::DDSCodec::mType`[private]`

Definition at line 48 of file OgreDDSCodec.h.

DDSCodec* Ogre::DDSCodec::msInstance`[static, private]`

Single registered codec instance.

Definition at line 65 of file OgreDDSCodec.h.

CodecList Ogre::Codec::ms_mapCodecs`[static, protected, inherited]`

A map that contains all the registered codecs.

Definition at line 55 of file OgreCodec.h.

The documentation for this class was generated from the following file:

- OgreDDSCodec.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Sun Jul 26 11:33:05 2009